;copywrite 2000 by Samuel Stearley


ti89


 ifnd ti89
ti92plus
 endc





	include	"os.h"


 ifd ti89
	xdef		_ti89
 endc


 ifd ti92plus
	xdef		_ti92plus
 endc


	xdef		_nostub



;The following macro is called debug.  It sets the carry flag and then enters the
;loop, which will of course continue for all eternity because the carry will not
;change.  This gives me time to right click on vti and select "enter debugger."
;Once in the debugger I will manually unset the carry flag.  Then I can single
;step through the program.



debug MACRO

	move	#1,ccr
\loop:
	bcs	\loop

	ENDM	


;---First thing to do is to find the pointer to the flag that tells me if
;---the cursor is in the entry line.  And then put it into code.


	movem.l	d3-d7/a2-a6,-(a7)
	move.l	a7,d7				;save stack pointer



	move.l	200,a6			;pointer to the jump table
	move.l	1080(a6),a0			;get pointer to the code of home execute call
	move.l	708(a6),d0			;get pointer to te_select- will search
							;  for this value in the code of the home execute
							;  call
search_loop:
	addq.l	#2,a0				;code is alligned on words
	cmp.l		(a0),d0			;is it the place to jsr too?
	bne		search_loop
	move.w	-4(a0),d0			;now got pointer to the tios entyline text edit
							;  structure.
	add.w		#32,d0			;point it to the flag

	lea		btst_opcode+4(pc),a0	;point to adress operand
	move.w	d0,(a0)			;move it into the ram

;---The Second thing to do is to get the pointer to the first window
;---and install it into my code

	move.l	824(a6),a0		;get send event call
	pea		event(pc)
	move.w	#-2,-(a7)		;current app
	jsr		(a0)

	move.l	(a6),a0		;get pointer to the first window pointer
	move.l	(a0),a0		;now get a pointer to the first window
	addq.w	#1,a0			;so it points to the byte with the active flag
	lea		tst_opcode+2(pc),a1;get pointer to operand part
	move.w	a0,(a1)		;move it into my code


;---SO NOW INSTALL MY EVENT HOOK----


	move.l	2700(a6),a5			;got pointer to old evhook
	lea		old_event(pc),a1		;get pointer to the save space
	move.l	(a5),(a1)			;save it

	move.l	#END_OF_HOOK-BEGINNING_OF_HOOK,d3	;amount of ram needed
	move.l	d3,-(a7)			;ram needed to copy code too
	move.l	584(a6),a0			;get heap allocate high call
	jsr		(a0)				;allocate it -d0 has the handle
	pea		error_message
	tst.w		d0				;check for success
	beq		memory_error
	move.w	d0,-(a7)			;push for dereferencing
	move.l	600(a6),a0			;get dereference call -ao points to allocated memory
	jsr		(a0)
	move.l	a0,a1				;save a quick copy
	add.l		#$40010,a0			;increase the first to bypass hw2 protection
	move.l	a0,(a5)			;overwrite old event handler
	subq.l	#1,d3				;for dbra
	lea		BEGINNING_OF_HOOK(pc),a0
copy_loop:
	move.b	(a0)+,(a1)+
	dbra		d3,copy_loop		;copy over the handler
	pea		message(pc)

memory_error:
	move.l	920(a6),a0			;help displag call
	jsr		(a0)

;---Restore Registers and exit the installation-----


final:
	move.l	d7,a7				;reset the stack
	movem.l	(a7)+,d3-d7/a2-a6		;get registers back
	rts

;------------------------------------------------------
;AND NOW THE STRINGS AND DATA OF THE INSTALLATION PART
;------------------------------------------------------

message:		dc.b		"Best View by Samuel Stearley (C) 2000",0
error_message:	dc.b		"Error: Not enough Memory",0

	EVEN	

event:
	dc.w		$710			;keypress event
	dc.w		0			;sender 		-will be filled by send event
	dc.w		0			;side is 0		-will be filled by send event
	dc.w		0			;status flags	-will be filled by send event
	dc.w		0
	dc.w		4360			;quit ekeypress




	EVEN		


;----------------------------------------------
;AND NOW FOR THE CODE OF THE HOOK
;----------------------------------------------

BEGINNING_OF_HOOK:
		dc.b	"evHkBestView"	;signature and name
old_event:	dc.l	0			;space for the old event



;----First check the event type and if the home
;----application is active.

	movem.l	d0-d7/a0-a6,-(a7)
	move.l	64(a7),a2			;get pointer to the event structure
	cmp.w		#$705,(a2)			;are applications changing, if so then restart some
							;  of my variables
	beq		restart_variables
	cmp.w		#$710,(a2)			;is it command keypress
	bne		pass_it_on

tst_opcode:
	tst.b		$1234				;garbage for the pointer to the first window
	bpl		pass_it_on			;if it is not on the home screen then I do nothing
btst_opcode:
	btst.b	#1,$1234			;garbage for the pointer to the cursor on the entry
							;  line flag.
	bne		pass_it_on			;if on the entry line then do nothing

;----Get the number of fifo nodes and the key-------

	move.l	200,a6			;get ptr to the jump table
	move.l	2292(a6),a0			;get count fifo node call
	jsr		(a0)				;count the fifo nodes
	move.w	d0,d7
	lsl.w		#1,d7				;double it
	subq.w	#1,d7				;decrease it

	lea		position(pc),a3		;place in the entry stack
	move.w	10(a2),d0			;get the key press


;----Start checking the keys-------

	cmp.w		#264,d0			;is it escape?
	beq		restart_variables

 ifd ti89
	cmp.w		#16721,d0			;is it diamond + up?
 endc

 ifd ti92plus
	cmp.w		#8530,d0			;is it diamond + up?
 endc

	bne		not_diamond_up

	move.w	d7,(a3)
	bra		pass_it_on

not_diamond_up:


 ifd ti89
	cmp.w		#16724,d0			;is it diamond + down?
 endc

 ifd ti92plus
	cmp.w		#8536,d0			;is it diamond +down?
 endc

	beq		restart_variables




	cmp.w		#13,d0			;is it enter?
	beq		restart_variables		;then done
	cmp.w		#263,d0			;is it clear?
	beq		account_for_deletion
	cmp.w		#257,d0			;is it backspace?
	bne		no_deletion

;----Code to account for deletion------

account_for_deletion:

	moveq.l	#-2,d6			;the mask	%1111111111111110
	and.w		d6,(a3)			;subtract 1 if odd - leave alone if even
	and.w		d6,d7				;do the same to the number of fifo nodes
	cmp.w		(a3),d7			;if they are equal then it was the very top fifo
							;  node that was deleted
	bne		pass_it_on
	subq.w	#1,(a3)			;decrease it again if it was the top
	bcc		pass_it_on
	clr.w		(a3)
	bra		pass_it_on

no_deletion:


;----Now for the up and down arrows-------


 ifd ti89

	cmp.w		#337,d0			;is it up?
	beq		increment_position
	cmp.w		#340,d0			;is it down?
	bne		do_not_decrement_position

 endc

 ifd ti92plus

	cmp.w		#338,d0			;is it up?
	beq		increment_position
	cmp.w		#344,d0			;is it down?
	bne		do_not_decrement_position

 endc

;----Code to decrement the position---

	subq.w	#1,(a3)
	bcc		pass_it_on
	clr.w		(a3)
	bra		pass_it_on

;----Code to increment the position---

increment_position:

	cmp.w		(a3),d7
	beq		pass_it_on			;if it is at the limit then do nothing
	addq.w	#1,(a3)
	bra		pass_it_on

do_not_decrement_position:

	cmp.w		#269,d0			;is it the f2?
	bne		pass_it_on

;--------------------------------------------
;
;IF IT WAS F2 THEN DISPLAY IT!!!!
;
;--------------------------------------------


	movem.l	a2,-(a7)			;save the pointer to the event
	move.l	a7,d3				;SAVE THE STACK POINTER
	move.w	#$700,(a2)			;make it command idle
	move.l	1060(a6),a5			;get pointer to top estack
	move.l	(a5),d7			;save top estack
	lea		-250(a7),a7			;allocate memory for the window
	move.l	a7,a4				;a4 is pointer to the window



;----Get the handle of what to display-----

	move.l	2308(a6),a0			;get the "get answer call"
	move.w	(a3),d0			;get the position
	lsr.w		#1,d0				;divide by two and test for odd or even
	bcc		even_so_answer
	move.l	2312(a6),a0	
even_so_answer:
	addq.w	#1,d0
	move.w	d0,-(a7)
	jsr		(a0)				;get the handle
	
;-----------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------

	move.w		d0,-(a7)			;handle of the answer or entry
	beq			window_was_not_made
	move.l		2332(a6),a0			;handle to esi
	jsr			(a0)				;make the call
	move.l		a0,a2				;save the esi
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	move.w		#$300,-(a7)			;THESE ARE THE WINDOWS FLAGS
	pea			rect(Pc)			;THE BORDERS OF THE WINDOW
	move.l		a4,-(a7)			;the window
	move.l		120(a6),a0			;It is smaller to do make the call this way
	jsr			(a0)
	tst.b			d0				;CHECKS IF THE CALL WAS SUCCESSFUL
	beq			window_was_not_made	;ZERO IF AN ERROR
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	clr.w			-(a7)				;INPUT
	move.l		a2,-(a7)			;THIS IS THE ESI
	move.l		296(a6),a0			;parse it
	jsr			(a0)
	move.l		a0,a2				;SAVE THE RESULT
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	pea			top_half(pc)		;THESE ARE THE INPUTS.
	pea			bottom_half(pc)		;VALUES ARE STORED TO THE PLACES THEY
	pea			width(pc)			;POINT TO, d0 IS THE SAME AS TOP_HALF
	push.l		a2				;PUSH THE RESULT OF THE PARSE2D CALL
	move.l		308(a6),a0
	jsr			(a0)
	moveq			#0,d5				;initial X is zero
	move.w		d0,d6				;Get the Y of the thing to be displayed
	move.w		d6,d4				;this copy will not be altered
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
;EVERYTHING BEFORE THIS POINT WAS JUST SET UP.  THE FOLLOWING CODE IS THE MAIN LOOP THAT
;TAKES KEYPRESSES AND SCROLLS THE ANSWER AND CLEARS THE SCREEN BETWEEN THE SCROLLING.
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
REDRAW_THE_SCREEN:
	move.l		a4,-(a7)			;window that needs to be cleared
	move.l		48(a6),a0
	jsr			(a0)
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	move.w		d6,-(a7)			;push the y
	move.w		d5,-(a7)			;push the x
	move.l		a4,-(a7)			;the window
	move.l		a2,-(a7)			;the result of the parse 2d
	move.l		304(a6),a0			;print 2d call
	jsr			(a0)
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
	lea			16(a7),a7			;in a loop so stack needs to be reset
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
get_another_key_press:

	clr.l			-(a7)
	clr.w			-(a7)
	move.l		1528(a6),a0			;idle call
	jsr			(a0)
	addq.l		#6,a7

	cmp.w			#264,d0
	beq			quit

 ifd ti89
	cmp.w			#344,d0
	beq			scroll_right
	cmp.w			#338,d0
	beq			scroll_left
	cmp.w			#340,d0
	beq			scroll_down
	cmp.w			#337,d0
	beq			scroll_up
 endc

 ifd ti92plus
	cmp.w			#340,d0
	beq			scroll_right
	cmp.w			#337,d0
	beq			scroll_left
	cmp.w			#344,d0
	beq			scroll_down
	cmp.w			#338,d0
	beq			scroll_up
 endc

	bra			get_another_key_press
;------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------
scroll_right:
	move.w		d5,d1				;copy of x
	add.w			width(pc),d1		;add the width to the x


 ifd ti89
	cmp.w			#160,d1
 endc

 ifd ti92plus
	cmp.w			#240,d1
 endc
								;if the width and the x combine to be less than
	bcs			get_another_key_press	;the screen width then it stops it from being
	add.w			#-40,d5			;scrolled anymore.  Remember that the x may be
	bra			REDRAW_THE_SCREEN		;negative.
scroll_left:
	tst.w			d5				;keeps it within bounds the initial x was zero
	beq			get_another_key_press	;so if x is currently zero then it can not be
	add.w			#40,d5			;scrolled left.
	bra			REDRAW_THE_SCREEN
scroll_up:
	cmp.w			d4,d6				;check if the current y is the same as the
	beq			get_another_key_press	;initial y, this is similar to the limitations
	add.w			#28,d6			;of the scroll left, except that the initial y
	bra			REDRAW_THE_SCREEN		;can vary and so must be stored in a register.
scroll_down:
	move.w		d6,d0				;add the y to the bottom half and if the result
	add.w			bottom_half(pc),d0	;is greater than the height of the screen then

 ifd ti89
	cmp.w			#93,d0
 endc

 ifd ti92plus
	cmp.w			#121,d0
 endc
								;the variable can not be scrolled.  Remember
	bcs			get_another_key_press	;that y may be negative.
	add.w			#-28,d6
	bra			REDRAW_THE_SCREEN
quit:

	move.l		a4,-(a7)
	move.l		44(a6),a0			;window close call
	jsr			(a0)				;close it

window_was_not_made:

	move.l		d3,a7				;RESET THE STACK
	move.l		d7,(a5)			;reset the expression stack
	move.l		(a7)+,a2
	bra			pass_it_on



;----code to pass on the event to the next level------


restart_variables:
	lea		variables(pc),a0
	clr.w		(a0)


;----Now for some code to pass the event on to tios or the next hook----


pass_it_on:
	move.l	old_event(pc),a0		;get the old event handler
	move.l	a0,d0				;test it
	beq		no_old_hook
	move.l	a2,-(a7)			;input for the event handler
	jsr		(a0)				;call the next event handler
	addq.l	#4,a7				;pop it off
no_old_hook:
	movem.l	(a7)+,d0-d7/a0-a6		;get the saved registers
	rts

;-----------------------------------------
;AND NOW FOR THE VARIABLES OF MY HOOK
;-----------------------------------------

variables:
position:		dc.w		0

 ifd ti89
rect			dc.w		0,0,160,92
 endc

 ifd ti92plus
rect:			dc.w		0,0,240,120
 endc

width		dc.w		0
bottom_half	dc.w		0
top_half	dc.w		0



END_OF_HOOK:


	end		

